import re

"""
This's the markup module, here there are classes and functions needed to powerfully manage markup, tag, and markup encoding.
Good lucky
"""
#~ reFlags="re.I|re.L|re.S|re.U"
#~ MetaTags=r'(?<=[<]meta name="%s" content=")(.+?)(?=")>'
#~ GenericTag=r'(?<=[<]%s[>])(.+?)(?=[<]/%s[>])'
#~ ATag=r'<a[^>]+?(?<=rel="%s")[^<]+?(?<=href=")(.+?)(?=").+?>'

def ghost(txt):
    """
    This is a ghost function that must do nothing
    """
    return []

#Here starts css part
def link_css(txt):
    """
    return a a list of match objects
    txt must be yet markup compatible
    """
    return re.compile(r"""url\((.+?)\)""").finditer(txt)


#here starts tex part
def link_tex(txt):
    pass

def title_tex(txt):
    pass

def author_tex(txt):
    pass

def date_tex(txt):
    pass

def header_tex(txt):
    pass

#Here starts xml part
def link_xml(txt):
    return re.compile(r"""<\?xml-stylesheet .*? href="(.+?)".*?\?>""").finditer(txt)
    
def charset_xml(txt):
    return re.compile(r"""^<\?xml .+? encoding=["']([^"']+)["'].*?\?> """).finditer(txt)

#Here we connect xsl to xml
def link_xsl(txt):
    return link_xml(txt)

#Here starts (x)html part
def link_html(txt):
    return re.compile(r"""(?:<[^<]+?(?:src|href)=\")(.+?)((#.+?)*\".*?/*>)""").finditer(txt)
    
def header_html(txt):
    return re.compile(r"""<(?:H1|H2|H3|H4|H5|H6)>(.+?)</\1>""").finditer(txt)

def anchor_html(txt):
    pass

def aname_html(txt):
    pass

def charset_html(txt):
    return re.compile(r"""< *meta *(?:http-equiv=\"content-type\")* content=".+?; *charset=(.+?)" */*>""").finditer(txt)

def metaAuthor_html(txt):
    pass
#here starts htm part
def link_htm(txt):
    return link_html(txt)

#Here startx python part
def link_py(txt):
    pass
    
    
#What you want
#---------------------

#Useful tools
def canParse(what,ext, default=ghost, where='__module__'):
    """
    return, if there is, an object of the form what_ext in the current module
    else a default object, that must be callable.
    ext must be provided as os.path.splitext does (whith the dot)
    """
    return hasattr(where,what+'_'+ext[1:]) and getattr(where,what+'_'+ext[1:]) or default


def string2validXML(String,encoding='ascii'):
    """
    Return a valid xml string encoded in ascii
    string must be an unicode object
    """
    return String.encode(encoding,"xmlcharrefreplace")


#Various classes
#Actually this's only a scratch
class tex:
    def __init__(self):
        #now we build the class interactively.
        self.inTex={'header':'','link':'','img':''}
        for el in self.inTex:
            self.inTex[el]=canParse(el,'.tex')
        
    def feed(self,AbsFilePath):
        self.myTex=open(AbsFilePath,'r').read()


##class BettSGML(sgmllib.SGMLParser):
##    def __init__(self,absFile):
##        self.thisHTML=open("absFile","r").read()
##        
##        #the class needs to know the declared language used in this document, to check its encoding
##        self.lang=re.compile(r'lang=\"*(.+?)\"* ',reFlags).search(self.thisHTML).group(1)
##        self.charset=re.compile(r'< *meta *(?:http-equiv=\"content-type\")* content=\".+?; *charset=(.+?)\"  */*>', re.IGNORECASE | re.UNICODE).search(self.thisHTML).group(1)
##        
##        #Now we have the correct encoding to read the file
##        self.thisHTML.encode(self.charset,"xmlcharrefreplace")
##        sgmllib.SGMLParser.__init__()
##
##
##    
##    def handle_data(self,data):
##        """
##        This function override the default one.
##        It check's wheter data is correctly encoded.
##        We use ascii as default encoding and any other character will be represented as
##        xml entity
##        """
##        return data.encode("ascii","xmlcharrefreplace")
##    
##    def start_a(self,attributes):
##        pass

if __name__=='__main__':
    print 'test txt->xml'
    print string2validXML(unicode('ciao>','latin1'))
