#-*- coding: latin1 -*-
import os,re,string
import libWrap

"""
This application try to extract all links(href,src) in a (X)HTML file and then
check if the file exsists.
If it exsists it print the full HTML code relative to the link in black else it
will be in red.
Tag and attribute are in bold, href/src value is underlined.
"""
root=r'D:\astyonax\linBuff\Sito_new'
dest=os.pardir+ r"/LinkVer_report.html"    #where the generated map will be saved
pollo=[]                                                     #A list containing the full map line by line.
outputEncoding='ascii'
pollo.append(unicode('<html>\n<head>\n<title>Link verify report</title>\n<link rel="stylesheet" href="stile_rep.css" type="text/css">\n<style type="text/css">.ok{display:inline;}.red { color: rgb(153, 0, 0);}</style>\n<body>',outputEncoding,'xmlcharrefreplace'))
pollo.append('<h1>Link verifier report</h1>')
useUnicode=0    #Works on reading
correct=1
correctPermanently=1

print 'Setting up...'
if os.path.exists(dest):
    os.remove(dest)
if useUnicode:
    from libUnicode import *
else:
    UniOpen=open    

refs=[]
yet_done=[]
exts=('.htm','.html','.gif','.jpg','.png','.xml','.xhtml','.css','.js','.py')


def points(dir):
    if dir in yet_done:return
    def ok(mah,dirn,Nf):
        for el in Nf:
            if  os.path.splitext(el)[1] in exts:
                a=os.path.normpath(dirn)
                refs.append((a,el)) 
    if calc_level(os.path.normpath(dir))<calc_level(root):
        #It may be that some broken link points out of the  root directory.
        #It may be dangerous for privacy and a bit slower to indicise also files out of the site.
        #Althought it may give anormal results in links repairing process.
        dir=root
    for x in xrange(len(dir.split(os.sep))):
        if dir not in yet_done:
            yet_done.append(dir)
            print "\nIndexing process now started; if your site root directory contains a lof of files it may takes a lot.\nDon't worry it never crashed also in 1GB sites."
            print "This process is runned only once for directory tree!"
            print 
            os.path.walk(dir,ok,0)

def findLnkPnt(lnk):
    dir=lnk.split(os.sep)[:-1]
    reqFile=str(lnk.split(os.sep)[-1:])
    #print reqFile
    #~ for x in xrange(len(dir)-1):
     #  print (os.sep).join(dir[len(dir)-1-x])
        #~ points((os.sep).join(dir[len(dir)-1-x]))
        #~ for el in refs:
           #~ # print reqFile
            #~ if el[1] in reqFile:
                #~ return str(el[0])+os.sep+str(el[1])
                #~ break
    #Initial idea was to make the index only of the smallest part needed to find a result.
    #Obviously it isn't a good idea
    points(root)
    collected_Results=[]
    for el in refs:
        if el[1] in reqFile:
            collected_Results.append(str(el[0])+os.sep+str(el[1]))
    print "\tResults:"
    print "\t\t",
    print "\n\t\t".join(collected_Results)
    print 
    if len(collected_Results)>1:
        return ('<br/>'.join(collected_Results),len(collected_Results))
    else:
        return (''.join(collected_Results),len(collected_Results))

def corrlnk(file,link,new):
    print "fixing permanently broken link"
    print "File: ", file
    print "old link: ", link
    print "new one: ", new
    myFile=UniOpen(file,"r").read()
    myFile=myFile.replace(link,new)
    open(file,"w").write(myFile)

def BuildLnkHref(file,aHref):
    """
    Return the correct relative link to be placed in file pointing to aHref as string
    
    """
    """
    D:\astyonax\linBuff\Sito_new\Dealing\index.html
    D:\astyonax\linBuff\Sito_new\images\png\fack.png
    ..\images\
    """
    fileArr=file.split(os.sep)
    aHrefArr=aHref.split(os.sep)
    for x in xrange(min((len(fileArr),len(aHrefArr)))):
        if fileArr[x]!=aHrefArr[x]:
            remain=len(fileArr[x:])-1
            print remain
            #it counts also the file, but I'm not interested in 
            #correct codec would be len(fileArr[(x-1):])-1 but the two -1 are make null their work.
            #the first says thak one more element, the second reject it.
            return ("../"*remain) + "/".join(aHrefArr[(x):])

def linkVer(deep,dirname,names):
    link_pattern=re.compile(r'(<[^<]+?(?:src|href)=")(.+?)((#.+?)*".*?/*>)',re.I|re.L|re.S)
    pollo.append(r'<h2>'+dirname+'</h2>')
    print 'entering:: ' +dirname
    for el in names:
        
        if not(os.path.isdir(dirname+os.sep+el) or os.path.islink(dirname+os.sep+el)) and (os.path.splitext(el)[1] in ('.html','.htm','.xhtml')): 
            pollo.append('<hr/><h3>'+dirname+os.sep+el+' </h3><a href="'+dirname+os.sep+el+'">Go</a><p>')
            my_file=UniOpen(dirname+os.sep+el,'r')
            my_HTML=my_file.read()
            my_file.close()
            #Now we have the code, we needs of regex to extract these infos about links.
            links=link_pattern.findall(my_HTML)

            for link in links:
                if link[1][:1]!='#' and string.find(link[1],'://')==-1 and string.find(link[1].lower(),'javascript:')==-1:  #per ora gestisco solo i link a file locali
                    #Here we reject all anchors, absolute and javascript varieties af links.
                    #Regex pattern yet return only the interesting part of the url, discarding # part.
                    #for local url we hope they are standards and starts with file:// else we don't recognise them.
                    link0=string.replace(string.replace(link[0],'<','&lt;'),'>','&gt;')
                    link1=string.replace(string.replace(link[1],'<','&lt;'),'>','&gt;')
                    link2=string.replace(string.replace(link[2],'<','&lt;'),'>','&gt;')
                    link_infos=link0+'<strong>'+link1+'</strong>'+link2
                    if not(os.path.exists(prep_URL(dirname,link[1]))):
                        RU=""
                        if correct:
                            print "\ttrying to resolve broken link"
                            print '\t\t',prep_URL(dirname,link[1])
                            print "\t\t",dirname+os.sep+el
                            ru=findLnkPnt(prep_URL(dirname,link[1]))
                            RU=ru[0]
                        if correctPermanently and ru[1]==1:
                            print "\tcorrect link is:\n\t\t",
                            print BuildLnkHref(dirname+os.sep+el,RU)
                            corrlnk(dirname+os.sep+el,link[0]+link[1]+link[2],link[0]+BuildLnkHref(dirname+os.sep+el,RU)+link[2])
                            
                            RU=RU+"<strong> __Corrected__</strong>"
                        style='red'
                    else:
                        RU=""
                        style='ok'
                    pollo.append('<span class="'+style+'">'+link_infos+' <a href="'+link1+'">Go</a></span><br/>'+RU)    
                elif prep_URL(dirname,link[1],1)==1:
                    pollo.append('<br><strong> ---local---</strong><br>'+link[1]+'<br>')
                pollo.append('</p>')

def calc_level(path):
    #~ return string.count(path,os.sep)+1
    return len(path.split(os.sep))

def prep_URL(base,path,type=0):
    #base is the url of the current file, path the link path.
    if  string.find(path,r'file://')!=-1  or re.search("[A-W]://",path): #link locale
        if not(type):
            return os.path.normpath(path)
        else:
            return 1
    elif string.find(path,r'://')!=-1: #link esterno con vari protocolli ma non file
        if not(type):
            return path
        else:
            return 2
    elif path[:2]!=r'../':   #link relativo e profondo
        for i in range(1,calc_level(path)):                                                  #it run these operation for each os.sep in the relative path.
            base=base[base.find(os.sep)+1:]
        return os.path.normpath(base+os.sep+path)
    else:
        return 'boh'

os.path.walk(root,linkVer,0)  
open(dest,"w").writelines(pollo)
raw_input('ended')