import os,re,string
import libWrap,libMarkup
from libOS import *

"""
This application try to extract all links(href,src) in a all files it can handle and then
check if the uri exsists.
If it exsists it print the full HTML code relative to the link in black else it
will be in red.
Tag and attribute are in bold, href/src value is underlined.
NOTE:
Actually works only on local files
"""

#Configuration
root=r'D:\astyonax\linBuff\Sito_new'
dest="LinkVer_report.html"    
Heading='<html>\n<head>\n<title>Link verify report</title>\n<link rel="stylesheet" href="stile_rep.css" type="text/css">\n<style type="text/css">.ok{display:inline;}.red { color: rgb(153, 0, 0);}</style>\n<body>'
Heading=Heading+'<h1>Link verifier report</h1>'
correct=0
correctPermanently=0

#don't Works at all, set True at your own danger
#useUnicode=0
#outputEncoding='ascii'
#~ if os.path.exists(dest):
    #~ os.remove(dest)
#~ if useUnicode:
    #~ from libUnicode import *
#~ else:
    #~ open=open    
    
#Global arrays, don't modify, if don't now how and why!!!
RU=''
refs=[]
yet_done=[]
parsable=('.htm','.html','.xhtml')
possibleFile=('.htm','.html','.gif','.jpg','.png','.xml','.xhtml','.css','.js','.py')
criteria=[[1,0,0,1],parsable]
link_pattern=re.compile(r'(<[^<]+?(?:src|href)=")(.+?)((#.+?)*".*?/*>)',re.I|re.L|re.S)

def writeOutput(txt):
    """
    OutFile was opened as w+a
    """
    OutFile.write(txt)

def points(dir):
    """
    build and update an array with all files in the current root tree.
    Influencing a lot the fixing algori.. , at now, we make the full index one time for all.
    """
    if dir in yet_done:return
    
    def ok(mah,dirn,Nf):
        # This function is needed by os.path.walk()
        for el in Nf:
            if  os.path.splitext(el)[1] in possibleFile:
                refs.append((dirn,el)) 
    
    if len(dir)<len(os.path.abspath(root)):
        #It may be that some broken link points out of the  root directory.
        #It may be dangerous for privacy and a bit slower indexing also files out of the site.
        #Althought it may give anormal results in links repairing process.
        dir=root
    
    for x in xrange(len(dir.split(os.sep))):
        if dir not in yet_done:
            yet_done.append(dir)
            print "\nIndexing process now started; if your site root directory contains a lof of files it may takes a lot.\nDon't worry it never crashed also in 1GB sites."
            print "This process is runned only once for directory tree!"
    
            os.path.walk(dir,ok,0)

def findLnkPnt(lnk):
    dir=lnk.split(os.sep)[:-1]
    reqFile=str(lnk.split(os.sep)[-1:])
    #print reqFile
    #~ for x in xrange(len(dir)-1):
     #  print (os.sep).join(dir[len(dir)-1-x])
        #~ points((os.sep).join(dir[len(dir)-1-x]))
        #~ for el in refs:
           #~ # print reqFile
            #~ if el[1] in reqFile:
                #~ return str(el[0])+os.sep+str(el[1])
                #~ break
    #Initial idea was to make the index only of the smallest part needed to find a result.
    #Obviously it isn't a good idea
    points(root)
    collected_Results=[]
    for el in refs:
        if el[1] in reqFile:
            collected_Results.append(str(el[0])+os.sep+str(el[1]))
    print "\tResults:"
    print "\t\t",
    print "\n\t\t".join(collected_Results)
    print 
    if len(collected_Results)>1:
        return ('<br/>'.join(collected_Results),len(collected_Results))
    else:
        return (''.join(collected_Results),len(collected_Results))

def corrlnk(file,link,new):
    #~ print "fixing permanently broken link"
    #~ print "File: ", file
    #~ print "old link: ", link
    #~ print "new one: ", new
    myFile=open(file,"r").read()
    myFile=myFile.replace(link,new)
    open(file,"w").write(myFile)

def BuildLnkHref(file,aHref):
    """
    Return the correct relative link to be placed in file pointing to aHref as string
    
    D:\astyonax\linBuff\Sito_new\Dealing\index.html
    D:\astyonax\linBuff\Sito_new\images\png\fack.png
    ..\images\
    """
    fileArr=file.split(os.sep)
    aHrefArr=aHref.split(os.sep)
    for x in xrange(min((len(fileArr),len(aHrefArr)))):
        if fileArr[x]!=aHrefArr[x]:
            remain=len(fileArr[x:])-1
            print remain
            #it counts also the file, but I'm not interested in 
            #correct codec would be len(fileArr[(x-1):])-1 but the two -1 are make null their work.
            #the first says thak one more element, the second reject it.
            return ("../"*remain) + "/".join(aHrefArr[(x):])

def linkVer(deep,dirname,names):
    """
    Link Veryfier core.
    for el in libMarkup.canParse('link',os.path.splitext(navigate)[1],libMarkup.ghost,libMarkup)(open(navigate,'r').read()):
    """
    
    writeOutput('<h2>'+dirname+'</h2>')
    print 'entering:: ' +dirname
    
    for el in filer(names,dirname,criteria):
        writeOutput('<hr/><h3>'+dirname+os.sep+el+'</h3><a href="'+dirname+os.sep+el+'">Go</a><p>')
        
        my_HTML=open(dirname+os.sep+el,'r').read()
        links=link_pattern.findall(my_HTML)

        for link in links:
            if what_URL(link[1],'local'):
                
                #Here we reject all anchors, absolute and javascript varieties af links.
                #Regex pattern yet return only the interesting part of the url, discarding # part.
                
                link0=string.replace(link[0],'<','&lt;')
                link1=string.replace(string.replace(link[1],'<','&lt;'),'>','&gt;')
                link2=string.replace(link[2],'>','&gt;')
                link_infos=link0+'<strong>'+link1+'</strong>'+link2
                
                if not(os.path.exists(prep_URL(dirname,link[1]))):
                    
                    # css style class for output file
                    style='red'
                    
                    # broken link fixing
                    if correct:
                        
                        print "\ttrying to resolve broken link"
                        print '\t\t',prepPath(link[1],dirname)
                        
                        ru=findLnkPnt(prepPath(link[1],dirname))
                        RU=ru[0]
                        
                    if correctPermanently and ru[1]==1:
                        # ru[1] contains the number of correct links
                        
                        print "\tcorrect link is:\n\t\t",
                        print BuildLnkHref(dirname+os.sep+el,RU)
                        
                        corrlnk(dirname+os.sep+el,link[0]+link[1]+link[2],link[0]+BuildLnkHref(dirname+os.sep+el,RU)+link[2])
                        
                        RU=RU+"<strong> __Corrected__</strong>"
                    
                else:
                    style='ok'
                
                writeOutput('<span class="'+style+'">'+link_infos+' <a href="'+link1+'">Go</a></span><br/>'+RU)

            elif what_URL(link[1],'file'):
                writeOutput('<strong>---local---</strong><br/>\
                '+link[0]+link[1]+link[2]+'<br/>')
            
            writeOutput('</p>')

def calc_level(path):
    return len(path.split(os.sep))

def what_URL(path,filter=['local'],operator=0):
    """
    filter is a tuple of values, return a link if link attributes match exactly the filter else None
    """
    linkAtt='local'
    if (protocolMatch=re.compile(r"(^.+?)://").match(path)):
        protocol=protocolMatch.group(1)
        linkAtt=protocol.lower()
    
    if protocol and protocol.lower()=='file':
        # This's a local and absolute file
        linkAtt='file'
    
    if "javascript:" in path.lower():
        # This's a javascript link, like       href="javascript:history.go(-1)"
        linkAtt='javascript'
    
    if linkAtt in filter:
        return path
    return None
    
    

if __name__=='__main__':
    os.chdir(root)
    root=os.curdir
    
    #Initialize the output file
    OutFile=open(dest,"w+a")
    writeOutput(Heading)
    
    #Main part
    os.path.walk(root,linkVer,0)  
    
    #Closing activity
    OutFile.close()
    raw_input('ended')